﻿/**
* 
* グリッド配置コンテナ
* 
* @author nutsu
* @version 0.5
* 
*/

package nutsu.display {
	
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.geom.Point;
	
	public class GridContainer extends Sprite{
		
		//layout rule
		protected var gridlayout:GridLayout;
		
		//display objects
		protected var items:Array;
		
		//grid size
		public var gridWidth:Number;
		public var gridHeihgt:Number;
		
		/**
		* Constructor
		* @param	grid layout
		* @param	grid width
		* @param	grid height
		*/
		public function GridContainer( gl:GridLayout, gwidth:Number=1, gheight:Number=1 ){
			super();
			gridlayout = gl;
			items = new Array();
			gridWidth  = gwidth;
			gridHeihgt = gheight;
		}
		
		/**
		* 行列でDisplayObject取得
		* @param	行
		* @param	列
		* @return
		*/
		public function getChildByMarix( m:int, n:int ):DisplayObject{
			var index:int = gridlayout.getIndex( m, n );
			if( index<items.length ){
				return items[index];
			}else{
				return null;
			}
		}
		
		//---------------------------------------------------------------
		
		/**
		* 追加
		* @param	DisplayObject
		* @return	void
		*/
		private function addToGrid( d:DisplayObject ):void{
			items.push( d );
			setPos( d, items.length-1 );
		}
		
		/**
		* 削除
		* @param	DisplayObject
		* @return	void
		*/
		private function removeFromGrid( d:DisplayObject ):void{
			var i:int = items.indexOf( d );
			items.splice( i , 1 );
			for( var j:int=i;j<items.length;j++ ){
				setPos( items[j], j );
			}
		}
		
		/**
		* 配置
		* @param	DisplayObject
		* @param	gridIndex
		* @return	void
		*/
		private function setPos( d:DisplayObject, gridIndex:int ):void{
			var pos:Point = gridlayout.getLayoutPos( gridIndex );
			d.x = pos.x * gridWidth;
			d.y = pos.y * gridHeihgt;
		}
		
		/**
		* Override Sprite Container
		*/
		public override function addChild( d:DisplayObject ):DisplayObject{
			addToGrid( d );
			return super.addChild(d);
		}
		public override function addChildAt( d:DisplayObject, index:int ):DisplayObject{
			addToGrid( d );
			return super.addChildAt(d,index);
		}
		public override function removeChild( d:DisplayObject ):DisplayObject{
			removeFromGrid( d );
			return super.removeChild(d);
		}
		public override function removeChildAt( index:int ):DisplayObject{
			var d:DisplayObject = super.removeChildAt(index);
			removeFromGrid( d );
			return d;
		}
	}
	
}
